#ifndef __PEER_H__
#define __PEER_H__











#define MAXMSGLEN  1024
#ifdef MAXNAMELEN
#define MAXNAMELEN 128
#endif

#define FILE_NUMBER 256
#define BUF_SIZE 2000 //size of buffer
#define SOCK_PATH "parent_socket"
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>
#include <errno.h>
#include <dirent.h>
#include <stdlib.h> //exit()
#include "sockcomm.h"
#include <stdio.h>

/* print the commands of peer system */
void print_manual()
{
  printf("\n***********************************************\n");
  printf("1. list: List Online Clients\n");
  printf("2. IM: Send Instant Message\n");
  printf("3. get: get file-name\n");
  printf("4. files: list the files in the my shared directory\n");
  printf("5. quit: terminate the program\n");
  printf("***********************************************\n");
}

/*
  Used by a new peer host to join the system
  throught host 'peerhost'.
*/
int join(char *peerhost, ushort peerport)
{
  int sd;
  struct sockaddr_in myaddr;
  int addrlen;
  int ret_val;

  sd = ConnectToServer(peerhost, peerport);

  /* 
     FILL HERE:
     use getsockname() to find the port number
  */
  
  printf("admin: connected to peer host on '%s' at '%hu' thru '%hu'\n",
         peerhost, peerport, ntohs(myaddr.sin_port));

  return(sd);
}
char *msgSender;
  char *chatMsg;
  char stringListen[10];
  int m;
  
  int hJoinSock = -1; //socket for getting join requests
  int hListenSock = -1; //socket for getting the connection request of a peer to have a requested file
  int hDataSock = -1; //socket for receiving file from a peer
  int sock = -1; //socket for connecting to a specified upstream peer
  int livesdmax = 17; /* maximum active descriptor */
  fd_set readset,readset2; /* used for select() */
  fd_set livesdset,livesdset2; /* used to keep track of active descriptors */
  char szDir[256]; 
  DIR *dp;
  struct dirent *dirp;
  char filelist[2048]; /* contains all file names in the shared directory, separated by '\r\n' */
  char filelist_entry[FILE_NUMBER][256]; /* contains all file names in the shared directory */
  int filelist_size; /* contains all file names in the shared directory */
  char szBuffer[2048];
  struct hostent *myhostent,*peerent;
  struct sockaddr_in myhost_addr; //Address structure of this host
  struct in_addr myhost_ipaddr; //IP address of this host
  char** ptr; //pointer to address struct
  char myDnsName[100]; //host name of this node
  int namelen; //length of host name
  int ret_val; //return-value
  char* token; //pointer to token of message
  char* token1;	
  
  char msgDest[50];
  char chat[50];

  char filename[256]; //file name
  char path_filename[256]; //file name with absolute path
  char peer_ipaddr_buf[16]; //buffer for peer's IP address
  char peer_port_buf[16]; //buffer for peer's port
  char myhost_ipaddr_buf[16]; //buffer for this host's IP address
  char myhost_port_buf[16]; //buffer for this host's port
  struct peer_ipaddr; //peer's IP address

  
  struct sockaddr_in peer_sin;
  int peerlen;
  struct sockaddr_in addr1;
  u_short peer_port; //peer's port number
  enum boolean flag; //flag having either TRUE or FALSE
  struct sockaddr_in peer_addr;
  int addrlen; //length of peer_addr
  pid_t pid; //process id
  int peerNames_size = 0;
  char peerNames[50][50];

  char peerDnsName[50];
  
  char *myName;

  int peerlist[50]; //descriptor list of peers
  int peerlist_size = 0; //size of peerlist
  int socklist[50]; //descriptor list of sockets for IPC with child processes
  int socklist_size = 0; //descriptor list of sockets for IPC with child processes
  int i, j; //index
  char msg[MSG_SIZE]; //buffer for message
  int msg_size; //buffer size
  int sockfd[2]; // a pair of sockets for the communication between parent process and child process
  char peername[50];
  char msg_temp[MSG_SIZE];
  struct timeval timeout;
 
  int parent_soc=0;
  int temp_len;
  struct sockaddr_in l;
  socklen_t len_listen;
  struct hostent *peerEntry;
#endif
