/*
	csci5211 Fall 2005
	Programming Project 1: P2P File Sharing System
    Maker Name:
    Student ID:
    email address:
*/
#ifndef __SOCKCOMM_H
#define __SOCKCOMM_H

#include <sys/socket.h>
#include <string.h>
#include <sys/types.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>
#include <sys/uio.h>
#include <unistd.h>
#include <stdlib.h>
#include <strings.h> //bzero()
#include <sys/stat.h> //open()
#include <fcntl.h> //open()

int ConnectToServer(char* addr, int port);
int SocketInit(int port);
int AcceptConnection(int sockfd);
int ReadMsg(int fd, char* buff, int size);
int SendMsg(int fd, char* buff, int size);

/* macro constants */
//#define JOIN_PORT 8000
//#define ACCEPT_PORT 8001
#define JOIN_PORT 10419
//#define ACCEPT_PORT 28001
#define MSG_SIZE 2000 //size of message buffer
#define P2P_TIMER 10
//#define P2P_TIMER 5
//#define P2P_TIMER 100

/* enum definition */
enum boolean {FALSE, TRUE};

#endif
